{{

 TV Oscilloscope with sound

adapted from 
**********************************************
*  Parallax Propeller Bode Plot Demo (beta)  *
*  (C) 2005 Parallax, Inc.                   *
**********************************************
*  Coded by Beau Schwabe (Parallax)          *
**********************************************
      by Perry Mole      
      pjm@ridge-communications
      Oct 21, 2007 
}}

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000  
  _stack = ($3000 + $3000 + 100) >> 2   'accomodate display memory and stack

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

 

  basepin = 16   ' choose your video output pins

VAR

  long  mousex, mousey

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64]

  long  scopeX, scopeY, ScopeInput, Frequency, ctr, frq, temp, ScopeIndex, FreqSteps
  
  byte  ScopeBuffer[512]

OBJ

  tv    : "tv"
  gr    : "graphics"
  ADC   : "ADC_TV_sound_Modulator"
  Num   : "Numbers"
 
PUB start | i, j, k, kk, dx, dy, pp, pq, rr, numx, numchr , SampleWindow   

   'Start ADC

  ADC.SigmaDelta(@ScopeInput)    ' cog # 1
  
  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors

  tv_pins := (basepin & $38) << 1 | (basepin & 4 == 4) & %0101
  tv_pins |= %0011             ' turn on broadcast and aural
'  tv_broadcast := 55_250_000   ' set broadcast frequency to channel 2 
'  tv_broadcast := 61_250_000 '  ' set broadcast frequency to channel 3
'  tv_broadcast := 67_250_000 '  ' set broadcast frequency to channel 4
'  tv_broadcast := 77_250_000 '  ' set broadcast frequency to channel 5
  tv_broadcast := 83_250_000 '  ' set broadcast frequency to channel 6

  tv_auralcog := 1             ' set aural cog to 3 ADC started later    
  tv.start(@tv_status)         '
   
  'init colors
  repeat i from 0 to 64
    colors[i] := $00001010 * (i+4) & $F + $2B060C02

  'init tile screen
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
      
  SampleWindow := 240    
  'start and setup graphics
  gr.start                       ' cog #2
  gr.setup(16, 12, 128, 96, bitmap_base)
 
  gr.textmode(1,1,7,5)
  gr.colorwidth(1,0)  
  repeat

    'clear bitmap
    gr.clear

    'draw text
'    gr.textmode(1,1,7,5)
'    gr.colorwidth(2,0)
    gr.text(0,90,string("Propeller Oscilloscope"))
 
'    gr.textmode(1,1,7,%0101)
'    temp := UpperSweep/1000
'    gr.text(95,-87,Num.ToStr(temp,10))
'    gr.textmode(1,1,7,%0101)
'    temp := LowerSweep/1000
'    gr.text(-105,-87,Num.ToStr(temp,10))
'    gr.textmode(1,1,7,%0101)
'    gr.text(-5,-87,string("<--- KHz --->"))

    
    'draw oscilloscope grid
    repeat scopeX from -120 to 120 step 20
'                  gr.color(2)
                  gr.plot(scopeX,-80)
                  gr.line(scopeX,80)
    repeat scopeX from -120 to 120 step 5
'                  gr.color(2)
                  gr.plot(scopeX,-2)
                  gr.line(scopeX,2)
    repeat scopeY from -120 to 120 step 20
'                  gr.color(2)
                  gr.plot(-120,scopeY)
                  gr.line(120,scopeY)
    repeat scopeY from -80 to 80 step 5
'                  gr.color(2)
                  gr.plot(-2,scopeY)
                  gr.line(2,scopeY)   


    repeat ScopeIndex from 0 to 512 'SampleWindow-1 
      ScopeBuffer[ScopeIndex] := ScopeInput >> 4

    'draw Scope trace
'    gr.color(2)
    gr.plot(-120,ScopeBuffer[ 0 ]-63)
    repeat ScopeX from -119 to 119 
        gr.line(scopeX,ScopeBuffer[ 120 + ScopeX ]-63)
    gr.text(-105,-87,Num.ToStr(scopeBuffer[1],10)) 
    'copy bitmap to display
    gr.copy(display_base)

DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins      New Board
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    60_000_000      'broadcast
                        long    3              'auralcog